/* Interface for ActionCell class
 *
 * Copyright (C)  1993  The Board of Trustees of  
 * The Leland Stanford Junior University.  All Rights Reserved.
 *
 * Authors: Scott Francis, Paul Kunz, Imran Qureshi, and Libing Wang
 *
 * This file is part of an Objective-C class library for a window system
 *
 * Font.h,v 1.8 1994/12/08 19:43:45 pfkeb Exp
 */

/*
	This header file is a placeholder.
	It is holding this place so that Draw2.0 can be compiled on a sun.
	Currently there is no header file or class to match this header name.
	The class or header file will be implemented later.
			Scott Louis Francis
 */
 
 
#ifndef _Font_h_
#define _Font_h_

/* Flipped matrix */
#define NX_IDENTITYMATRIX  ((float *)  0)
#define NX_FLIPPEDMATRIX   ((float *) -1)

/* Space character */
#define NX_FIGSPACE        ((unsigned short) 0x80)

/* Font information */
typedef struct _NXFaceInfo {
    NXFontMetric *fontMetrics;      /* Informatin from afm file */
    int           flags;            /* Which font info is present. */
    struct _fontFlags   {           /* Keeps track of font usage for Confrming PS */
        unsigned int usedInDoc:1;   /* Has font beed used in document? */
        unsigned int usedInPage:1;  /* Has font beed used in page? */
        unsigned int usedInSheet:1; /* Has font been used in sheet?
                                       (There can be more than one
                                       page printed ona sheet of
                                       paper.) */
        unsigned int _PADDING:13;
    } fontFlags;
    struct _NXFaceInfo *nextFInfo;  /* Next record in list. */
} NXFaceInfo;

    
@interface Font:Object
{
    char         *name;        /* The font's name */
    float        size;         /* The font's size */
    int          style;        /* The font's style */
    float        *matrix;      /* The font's matrix */
    int          fontNum;      /* The user object referring to this font */
    NXFaceInfo   *faceInfo;    /* The font's face information */
    id           otherFont;    /* The associated screen font for this font */
    struct _fFlags    {
        unsigned int usedByWS:1;      /* True if the font is stored in
                                         the WIndow Server */
        unsigned int usedByPrinter:1; /* True if the font is stored in
                                         the printer */
        unsigned int isScreenFont:1;  /* Trye if the font is a screen font */
        unsigned int _PADDING:13;

#endif
