/*
    NXCachedImageRep - wrapped for cashing images

    Copyright (c) 1994, Adam Fedor.

    Implementation of display specific methods for X-Windows
*/

#include "NXCachedImageRep.h"
#include "Application.h"
#include "Window.h"
#include "dpsclient/xwfriends.h"

const char *NXCachedImageRepInstanceName(void)
{
    return "NXCachedImageRep";
}

@implementation NXCachedImageRep(ToolKit)

/* Copy the contents of our window to the lock-focused window */
- (BOOL)_displayDraw
{
    XWContext context;
    Drawable	  source;

    context = (XWContext)[NXApp context];
    if (!context->gstate->draw) {
	fprintf(stderr, "CachedImageRep: Focus not locked on any view\n");
	return NO;
    }
    if (!context->gstate->xgstate) {
	fprintf(stderr, "CachedImageRep: No gstate.\n");
	return NO;
    }
    source = (Drawable)[_window perform:@selector(_backingPixmap)];
    if (!source) {
	Widget mywidget = (Widget)[_window perform:@selector(_shell)];
	if (mywidget)
    	    source = XtWindow(mywidget);
    }
    if (!source) {
	fprintf(stderr, "Error (CachedImageRep): Not realized. Can't draw\n");
	return NO;
    }
    XCopyArea(context->display, 
		source,
		context->gstate->draw,
		context->gstate->xgstate,
		NX_X(&_rect),
		NX_Y(&_rect),
		NX_WIDTH(&_rect),
		NX_HEIGHT(&_rect),
		context->gstate->origin.x,
		context->gstate->origin.y);
    context->gstate->update = 1;
    return YES;
}

@end
