/*
    xwfriends - Definitions for X-Windows specific implementation of OpenStep

    Copyright (C) 1994, Adam Fedor

    We declare alot of the data as void* to avoid having to import alot
    of definitions files.

*/

#ifndef _GNUSTEP_DPSCLIENT_XWFRIENDS_H
#define _GNUSTEP_DPSCLIENT_XWFRIENDS_H

#define Object X11Object        /* To avoid problems with Objective C */
#define Window X11Window        /* To avoid problems with Objective C */
#include <X11/Intrinsic.h>
#undef Object
#undef Window

#include <dpsclient/event.h>

typedef struct _XWRect {
    NXPoint origin;
    NXSize  size;
} XWRect;

typedef struct _XWgstate_t {
    NXPoint 	origin;
    float 	scalex, scaley;
    float	rotation;
    XWRect	cliprect;
    GC		xgstate;
    Widget	widget;
    Drawable	draw;
    int		update;
} XWgstate_t, *XWgstate;
    
typedef struct _XWContext_t {
    Display	*display;
    XVisualInfo	vinfo;
    XStandardColormap	*map;
    void	*gstack;
    XWgstate	gstate;
} XWContext_t, *XWContext;

#endif
