/* NSObjCTypeSerializationCallBack protocol
 *
 * Callback Handling 
 */

@protocol NSObjCTypeSerializationCallBack
- (void)deserializeObjectAt:(id *)object
                   fromData:(NSData *)data
                 ofObjCType:(const char *)type
                   atCursor:(unsigned int*)cursor;
 /*
  * The implementor of this method decodes the referenced  object (which
  * should always be of type "@") located at the cursor postion in the data
  * object. The returned object is not autoreleased.  See description of
  * NSData method deserializeDataAt:ofObjCType:context:. 
  */
 
- (void)serializeObjectAt:(id *)object
               ofObjCType:(const char *)type
                 intoData:(NSMutableData *)data;
 /*
  * The implementor of this method decodes the referenced object (which
  * should always be of type "@") in the data object.  The returned object is
  * usually a copy.  See description of NSMutableData method
  * serializeDataAt:ofObjCType:context: 
  */
  
@end