/*
    objc-load.h - Dynamically load in Obj-C modules (Classes, Categories)

    Copyright (C) 1993, Adam Fedor.
    
    objc-load.h,v 1.6 1995/02/14 23:24:54 fedor Exp
*/

#ifndef _OBJC_LOAD_INCLUDE_
#define _OBJC_LOAD_INCLUDE_

#include <stdio.h>
#include <objc/objc.h>
#include <objc/objc-api.h>
#include <streams/streams.h>

#define objc_lookUpClass objc_lookup_class
struct mach_header 
{
    int nothing;
    
};

extern char *objc_executable_location();

extern long objc_load_module(
	char *filename,
	NXStream *errorStream,
	void (*loadCallback)(Class*, Category*),
        void **header,
        char *debugFilename);

extern long objc_unload_module(
	NXStream *errorStream,
	void (*unloadCallback)(Class*, Category*));

extern long objc_loadModules(
	char *files[],
	NXStream *errorStream,
        void (*callback)(Class*,Category*),
        struct mach_header **header,
        char *debugFilename);

extern long objc_unloadModules(
	NXStream *errorStream,
	void (*unloadCallback)(Class*, Category*));

#endif /* _OBJC_LOAD_H_ */
